=== modified file 'DBUS-API'
--- DBUS-API	2010-09-26 18:32:58 +0000
+++ DBUS-API	2011-02-27 17:26:35 +0000
@@ -149,8 +149,8 @@
 
 * Copyright
 
-    Copyright © 2010 Teddy Hogeborn
-    Copyright © 2010 Björn Påhlsson
+    Copyright © 2010-2011 Teddy Hogeborn
+    Copyright © 2010-2011 Björn Påhlsson
   
 ** License:
    

=== modified file 'README'
--- README	2010-09-26 18:32:58 +0000
+++ README	2011-02-27 17:26:35 +0000
@@ -162,8 +162,8 @@
 
 * Copyright
 
-    Copyright © 2008-2010 Teddy Hogeborn
-    Copyright © 2008-2010 Björn Påhlsson
+    Copyright © 2008-2011 Teddy Hogeborn
+    Copyright © 2008-2011 Björn Påhlsson
   
 ** License:
    

=== modified file 'debian/control'
--- debian/control	2010-10-01 18:40:55 +0000
+++ debian/control	2011-02-27 17:46:47 +0000
@@ -14,9 +14,9 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.6) | python-multiprocessing
+	python-urwid
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -37,6 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
+Conflicts: dropbear (<< 0.52-5)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2010-09-26 18:32:58 +0000
+++ debian/copyright	2011-02-27 17:26:35 +0000
@@ -5,8 +5,8 @@
 Upstream-Source: <http://www.fukt.bsnet.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2010 Teddy Hogeborn
-Copyright: Copyright © 2008-2010 Björn Påhlsson
+Copyright: Copyright © 2008-2011 Teddy Hogeborn
+Copyright: Copyright © 2008-2011 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2009-01-18 00:16:57 +0000
+++ debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
@@ -45,6 +45,7 @@
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
 	    /etc/keys/mandos/seckey.txt 2>/dev/null
+	update_initramfs
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
 	;;

=== modified file 'mandos'
--- mandos	2011-02-13 10:19:26 +0000
+++ mandos	2011-02-27 17:26:35 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1409,7 +1409,7 @@
 
     def add_pipe(self, parent_pipe):
         """Dummy function; override as necessary"""
-        pass
+        raise NotImplementedError
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
                      socketserver.TCPServer, object):
@@ -1614,7 +1614,7 @@
             else:
                 raise ValueError("Unknown suffix %r" % suffix)
         except (ValueError, IndexError), e:
-            raise ValueError(e.message)
+            raise ValueError(*(e.args))
         timevalue += delta
     return timevalue
 

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2010-09-27 18:57:12 +0000
+++ mandos-clients.conf.xml	2011-02-27 17:26:35 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -35,6 +35,7 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-11 17:45:21 +0000
+++ mandos-ctl	2011-02-15 19:53:46 +0000
@@ -22,7 +22,9 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
+
 import sys
 import dbus
 from optparse import OptionParser
@@ -31,43 +33,43 @@
 import re
 import os
 
-locale.setlocale(locale.LC_ALL, u'')
+locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
-    'Name': u'Name',
-    'Enabled': u'Enabled',
-    'Timeout': u'Timeout',
-    'LastCheckedOK': u'Last Successful Check',
-    'LastApprovalRequest': u'Last Approval Request',
-    'Created': u'Created',
-    'Interval': u'Interval',
-    'Host': u'Host',
-    'Fingerprint': u'Fingerprint',
-    'CheckerRunning': u'Check Is Running',
-    'LastEnabled': u'Last Enabled',
-    'ApprovalPending': u'Approval Is Pending',
-    'ApprovedByDefault': u'Approved By Default',
-    'ApprovalDelay': u"Approval Delay",
-    'ApprovalDuration': u"Approval Duration",
-    'Checker': u'Checker',
+    "Name": "Name",
+    "Enabled": "Enabled",
+    "Timeout": "Timeout",
+    "LastCheckedOK": "Last Successful Check",
+    "LastApprovalRequest": "Last Approval Request",
+    "Created": "Created",
+    "Interval": "Interval",
+    "Host": "Host",
+    "Fingerprint": "Fingerprint",
+    "CheckerRunning": "Check Is Running",
+    "LastEnabled": "Last Enabled",
+    "ApprovalPending": "Approval Is Pending",
+    "ApprovedByDefault": "Approved By Default",
+    "ApprovalDelay": "Approval Delay",
+    "ApprovalDuration": "Approval Duration",
+    "Checker": "Checker",
     }
-defaultkeywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK')
-domain = 'se.bsnet.fukt'
-busname = domain + '.Mandos'
-server_path = '/'
-server_interface = domain + '.Mandos'
-client_interface = domain + '.Mandos.Client'
+defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
+domain = "se.bsnet.fukt"
+busname = domain + ".Mandos"
+server_path = "/"
+server_interface = domain + ".Mandos"
+client_interface = domain + ".Mandos.Client"
 version = "1.2.3"
 
 def timedelta_to_milliseconds(td):
-    "Convert a datetime.timedelta object to milliseconds"
+    """Convert a datetime.timedelta object to milliseconds"""
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
             + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return (u"%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
+    return ("%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
             % { "days": "%dT" % td.days if td.days else "",
                 "hours": td.seconds // 3600,
                 "minutes": (td.seconds % 3600) // 60,
@@ -78,17 +80,17 @@
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
 
-    >>> string_to_delta('7d')
+    >>> string_to_delta("7d")
     datetime.timedelta(7)
-    >>> string_to_delta('60s')
+    >>> string_to_delta("60s")
     datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
+    >>> string_to_delta("60m")
     datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
+    >>> string_to_delta("24h")
     datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
+    >>> string_to_delta("1w")
     datetime.timedelta(7)
-    >>> string_to_delta('5m 30s')
+    >>> string_to_delta("5m 30s")
     datetime.timedelta(0, 330)
     """
     timevalue = datetime.timedelta(0)
@@ -98,15 +100,15 @@
         try:
             suffix = unicode(s[-1])
             value = int(s[:-1])
-            if suffix == u"d":
+            if suffix == "d":
                 delta = datetime.timedelta(value)
-            elif suffix == u"s":
+            elif suffix == "s":
                 delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
+            elif suffix == "m":
                 delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
+            elif suffix == "h":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
+            elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
                 raise ValueError
@@ -118,25 +120,25 @@
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
-            return u"Yes" if value else u"No"
-        if keyword in (u"Timeout", u"Interval", u"ApprovalDelay",
-                       u"ApprovalDuration"):
+            return "Yes" if value else "No"
+        if keyword in ("Timeout", "Interval", "ApprovalDelay",
+                       "ApprovalDuration"):
             return milliseconds_to_string(value)
         return unicode(value)
     
     # Create format string to print table rows
-    format_string = u' '.join(u'%%-%ds' %
-                              max(len(tablewords[key]),
-                                  max(len(valuetostring(client[key],
-                                                        key))
-                                      for client in
-                                      clients))
-                              for key in keywords)
+    format_string = " ".join("%%-%ds" %
+                             max(len(tablewords[key]),
+                                 max(len(valuetostring(client[key],
+                                                       key))
+                                     for client in
+                                     clients))
+                             for key in keywords)
     # Print header line
-    print format_string % tuple(tablewords[key] for key in keywords)
+    print(format_string % tuple(tablewords[key] for key in keywords))
     for client in clients:
-        print format_string % tuple(valuetostring(client[key], key)
-                                    for key in keywords)
+        print(format_string % tuple(valuetostring(client[key], key)
+                                    for key in keywords))
 
 def has_actions(options):
     return any((options.enable,
@@ -184,10 +186,10 @@
 	parser.add_option("-i", "--interval", type="string",
 	                  help="Set checker interval for client")
         parser.add_option("--approve-by-default", action="store_true",
-                          dest=u"approved_by_default",
+                          dest="approved_by_default",
                           help="Set client to be approved by default")
         parser.add_option("--deny-by-default", action="store_false",
-                          dest=u"approved_by_default",
+                          dest="approved_by_default",
                           help="Set client to be denied by default")
         parser.add_option("--approval-delay", type="string",
                           help="Set delay before client approve/deny")
@@ -204,18 +206,19 @@
 	options, client_names = parser.parse_args()
         
         if has_actions(options) and not client_names and not options.all:
-            parser.error('Options require clients names or --all.')
+            parser.error("Options require clients names or --all.")
         if options.verbose and has_actions(options):
-            parser.error('--verbose can only be used alone or with'
-                         ' --all.')
+            parser.error("--verbose can only be used alone or with"
+                         " --all.")
         if options.all and not has_actions(options):
-            parser.error('--all requires an action.')
+            parser.error("--all requires an action.")
         
         try:
             bus = dbus.SystemBus()
             mandos_dbus_objc = bus.get_object(busname, server_path)
         except dbus.exceptions.DBusException:
-            print >> sys.stderr, "Could not connect to Mandos server"
+            print("Could not connect to Mandos server",
+                  file=sys.stderr)
             sys.exit(1)
     
         mandos_serv = dbus.Interface(mandos_dbus_objc,
@@ -234,7 +237,8 @@
                 os.dup2(stderrcopy, sys.stderr.fileno())
                 os.close(stderrcopy)
         except dbus.exceptions.DBusException, e:
-            print >> sys.stderr, "Access denied: Accessing mandos server through dbus."
+            print("Access denied: Accessing mandos server through dbus.",
+                  file=sys.stderr)
             sys.exit(1)
             
 	# Compile dict of (clients: properties) to process
@@ -247,23 +251,24 @@
         else:
             for name in client_names:
                 for path, client in mandos_clients.iteritems():
-                    if client['Name'] == name:
+                    if client["Name"] == name:
                         client_objc = bus.get_object(busname, path)
                         clients[client_objc] = client
                         break
                 else:
-                    print >> sys.stderr, "Client not found on server: %r" % name
+                    print("Client not found on server: %r" % name,
+                          file=sys.stderr)
                     sys.exit(1)
             
 	if not has_actions(options) and clients:
 	    if options.verbose:
-	        keywords = ('Name', 'Enabled', 'Timeout',
-                            'LastCheckedOK', 'Created', 'Interval',
-                            'Host', 'Fingerprint', 'CheckerRunning',
-                            'LastEnabled', 'ApprovalPending',
-                            'ApprovedByDefault',
-                            'LastApprovalRequest', 'ApprovalDelay',
-                            'ApprovalDuration', 'Checker')
+	        keywords = ("Name", "Enabled", "Timeout",
+                            "LastCheckedOK", "Created", "Interval",
+                            "Host", "Fingerprint", "CheckerRunning",
+                            "LastEnabled", "ApprovalPending",
+                            "ApprovedByDefault",
+                            "LastApprovalRequest", "ApprovalDelay",
+                            "ApprovalDuration", "Checker")
             else:
                 keywords = defaultkeywords
             
@@ -285,44 +290,44 @@
                     client.StopChecker(dbus_interface=client_interface)
                 if options.is_enabled:
                     sys.exit(0 if client.Get(client_interface,
-                                             u"Enabled",
+                                             "Enabled",
                                              dbus_interface=dbus.PROPERTIES_IFACE)
                              else 1)
                 if options.checker:
-                    client.Set(client_interface, u"Checker", options.checker,
+                    client.Set(client_interface, "Checker", options.checker,
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.host:
-                    client.Set(client_interface, u"Host", options.host,
+                    client.Set(client_interface, "Host", options.host,
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.interval:
-                    client.Set(client_interface, u"Interval",
+                    client.Set(client_interface, "Interval",
                                timedelta_to_milliseconds
                                (string_to_delta(options.interval)),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.approval_delay:
-                    client.Set(client_interface, u"ApprovalDelay",
+                    client.Set(client_interface, "ApprovalDelay",
                                timedelta_to_milliseconds
                                (string_to_delta(options.
                                                 approval_delay)),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.approval_duration:
-                    client.Set(client_interface, u"ApprovalDuration",
+                    client.Set(client_interface, "ApprovalDuration",
                                timedelta_to_milliseconds
                                (string_to_delta(options.
                                                 approval_duration)),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.timeout:
-                    client.Set(client_interface, u"Timeout",
+                    client.Set(client_interface, "Timeout",
                                timedelta_to_milliseconds
                                (string_to_delta(options.timeout)),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.secret:
-                    client.Set(client_interface, u"Secret",
+                    client.Set(client_interface, "Secret",
                                dbus.ByteArray(open(options.secret,
-                                                   u'rb').read()),
+                                                   "rb").read()),
                                dbus_interface=dbus.PROPERTIES_IFACE)
                 if options.approved_by_default is not None:
-                    client.Set(client_interface, u"ApprovedByDefault",
+                    client.Set(client_interface, "ApprovedByDefault",
                                dbus.Boolean(options
                                             .approved_by_default),
                                dbus_interface=dbus.PROPERTIES_IFACE)
@@ -333,5 +338,5 @@
                     client.Approve(dbus.Boolean(False),
                                    dbus_interface=client_interface)
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2010-09-25 23:52:17 +0000
+++ mandos-ctl.xml	2011-02-27 17:26:35 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-11 17:45:21 +0000
+++ mandos-keygen	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-02-11 19:02:24 +0000
+++ mandos-monitor	2011-02-27 17:26:35 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2009,2010 Teddy Hogeborn
-# Copyright © 2009,2010 Björn Påhlsson
+# Copyright © 2009-2011 Teddy Hogeborn
+# Copyright © 2009-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2010-09-30 06:24:20 +0000
+++ mandos-monitor.xml	2011-02-27 17:26:35 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2010-09-14">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos.xml'
--- mandos.xml	2010-09-27 17:39:03 +0000
+++ mandos.xml	2011-02-27 17:26:35 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -34,6 +34,7 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2010-09-26 18:32:58 +0000
+++ plugins.d/askpass-fifo.c	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-26 21:27:28 +0000
+++ plugins.d/mandos-client.c	2011-02-27 17:26:35 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-11-05 18:30:07 +0000
+++ plugins.d/password-prompt.c	2011-03-08 11:08:35 +0000
@@ -24,7 +24,7 @@
 
 #define _GNU_SOURCE		/* getline(), asprintf() */
 
-#include <termios.h> 		/* struct termios, tcsetattr(),
+#include <termios.h>		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
@@ -35,7 +35,8 @@
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t, struct dirent, pid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t, struct dirent, pid_t,
+				   ssize_t, open() */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
 				   getenv(), free() */
 #include <dirent.h>		/* scandir(), alphasort() */
@@ -49,8 +50,8 @@
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
 #include <inttypes.h>		/* strtoumax() */
-#include <sys/stat.h> 		/* struct stat, lstat() */
-#include <string.h> 		/* strlen, rindex, memcmp */
+#include <sys/stat.h>		/* struct stat, lstat(), open() */
+#include <string.h>		/* strlen, rindex, memcmp */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -58,6 +59,7 @@
 				   ARGP_ERR_UNKNOWN */
 #include <sysexits.h>		/* EX_SOFTWARE, EX_OSERR,
 				   EX_UNAVAILABLE, EX_IOERR, EX_OK */
+#include <fcntl.h>		/* open() */
 
 volatile sig_atomic_t quit_now = 0;
 int signal_received;
@@ -65,9 +67,8 @@
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
-/* Needed for conflic resolution */
-const char plymouthd_path[] = "/sbin/plymouth";
-
+/* Needed for conflict resolution */
+const char plymouth_name[] = "plymouthd";
 
 static void termination_handler(int signum){
   if(quit_now){
@@ -79,12 +80,13 @@
 
 bool conflict_detection(void){
 
-  /* plymouth conflicts with password-promt since both want to control the
-     associated terminal. Password-prompt exit since plymouth perferms the same
-     functionallity.
+  /* plymouth conflicts with password-prompt since both want to read
+     from the terminal.  Password-prompt will exit if it detects
+     plymouth since plymouth performs the same functionality.
    */
   int is_plymouth(const struct dirent *proc_entry){
     int ret;
+    int cl_fd;
     {
       uintmax_t maxvalue;
       char *tmp;
@@ -96,52 +98,96 @@
 	return 0;
       }
     }
-    char exe_target[sizeof(plymouthd_path)];
-    char *exe_link;
-    ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
+    
+    char *cmdline_filename;
+    ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
+		   proc_entry->d_name);
     if(ret == -1){
       error(0, errno, "asprintf");
       return 0;
     }
-  
-    struct stat exe_stat;
-    ret = lstat(exe_link, &exe_stat);
-    if(ret == -1){
-      free(exe_link);
-      if(errno != ENOENT){
-	error(0, errno, "lstat");
-      }
-      return 0;
-    }
-  
-    if(not S_ISLNK(exe_stat.st_mode)
-       or exe_stat.st_uid != 0
-       or exe_stat.st_gid != 0){
-      free(exe_link);
-      return 0;
-    }
-  
-    ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
-    free(exe_link);
-    if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-       (memcmp(plymouthd_path, exe_target,
-	       sizeof(plymouthd_path)-1) != 0)){
-      return 0;
-    }
+    
+    /* Open /proc/<pid>/cmdline */
+    cl_fd = open(cmdline_filename, O_RDONLY);
+    free(cmdline_filename);
+    if(cl_fd == -1){
+      error(0, errno, "open");
+      return 0;
+    }
+    
+    char *cmdline = NULL;
+    {
+      size_t cmdline_len = 0;
+      size_t cmdline_allocated = 0;
+      char *tmp;
+      const size_t blocksize = 1024;
+      ssize_t sret;
+      do {
+	/* Allocate more space? */
+	if(cmdline_len + blocksize + 1 > cmdline_allocated){
+	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
+	  if(tmp == NULL){
+	    error(0, errno, "realloc");
+	    free(cmdline);
+	    close(cl_fd);
+	    return 0;
+	  }
+	  cmdline = tmp;
+	  cmdline_allocated += blocksize;
+	}
+	
+	/* Read data */
+	sret = read(cl_fd, cmdline + cmdline_len,
+		    cmdline_allocated - cmdline_len);
+	if(sret == -1){
+	  error(0, errno, "read");
+	  free(cmdline);
+	  close(cl_fd);
+	  return 0;
+	}
+	cmdline_len += (size_t)sret;
+      } while(sret != 0);
+      ret = close(cl_fd);
+      if(ret == -1){
+	error(0, errno, "close");
+	free(cmdline);
+	return 0;
+      }
+      cmdline[cmdline_len] = '\0'; /* Make sure it is terminated */
+    }
+    /* we now have cmdline */
+    
+    /* get basename */
+    char *cmdline_base = strrchr(cmdline, '/');
+    if(cmdline_base != NULL){
+      cmdline_base += 1;		/* skip the slash */
+    } else {
+      cmdline_base = cmdline;
+    }
+    
+    if(strcmp(cmdline_base, plymouth_name) != 0){
+      if(debug){
+	fprintf(stderr, "\"%s\" is not \"%s\"\n", cmdline_base,
+		plymouth_name);
+      }
+      free(cmdline);
+      return 0;
+    }
+    if(debug){
+      fprintf(stderr, "\"%s\" equals \"%s\"\n", cmdline_base,
+	      plymouth_name);
+    }
+    free(cmdline);
     return 1;
   }
-
+  
   struct dirent **direntries;
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
   if (ret == -1){
     error(1, errno, "scandir");
   }
-  if (ret < 0){
-    return 1;
-  } else {
-    return 0;
-  }
+  return ret > 0;
 }
 
 
@@ -229,7 +275,7 @@
 
   if (conflict_detection()){
     if(debug){
-      fprintf(stderr, "Stopping %s because of conflict", argv[0]);
+      fprintf(stderr, "Stopping %s because of conflict\n", argv[0]);
     }
     return EXIT_FAILURE;
   }
@@ -437,8 +483,8 @@
 	break;
       }
     }
-    /* if(sret == 0), then the only sensible thing to do is to retry to
-       read from stdin */
+    /* if(sret == 0), then the only sensible thing to do is to retry
+       to read from stdin */
     fputc('\n', stderr);
     if(debug and not quit_now){
       /* If quit_now is nonzero, we were interrupted by a signal, and

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-11-16 18:10:22 +0000
+++ plugins.d/plymouth.c	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010 Teddy Hogeborn
- * Copyright © 2010 Björn Påhlsson
+ * Copyright © 2010-2011 Teddy Hogeborn
+ * Copyright © 2010-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.xml	2011-02-27 17:26:35 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-02-27">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -32,6 +32,7 @@
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2010-10-07 17:46:56 +0000
+++ plugins.d/splashy.c	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-09-26 18:32:58 +0000
+++ plugins.d/usplash.c	2011-02-27 17:26:35 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

